#pragma once

/**
 * @brief The possible boundary types.
 *
 */
enum class btype {
    NONE, /**< placeholder, which should not be used in real problems */
    OPEN, /**< open boundary with no restrictions */
    DIRICHLET, /**< Dirichlet boundary condition */
    NEUMANN, /**< Neumann boundary condition */
    PERIODIC, /**< periodic boundary condition */
    MIRROR, /**< mirror boundary condition */
    NEIGHBOR, /**< internal boundary that is used to exchange grid data with parallel instances */
};
