#pragma once
#include <cmath>

static int q_from_ns(N_Vector q, UserData& u1, UserData& u2){
    realtype *qdata, *n1data, *n2data;
    qdata = N_VGetArrayPointer(q);

    for ( size_t i =0; i<MX; i++){
//         qdata[i]=-1.+u2.q*n2data[i];
        qdata[i]=u1.q*u1.n[i]+u2.q*u2.n[i];
    }

    return 0;
}

static realtype E_from_q(N_Vector E, N_Vector q){
    realtype *Edata, *qdata;
    realtype energy = 0.;

    Edata = N_VGetArrayPointer(E);
    qdata = N_VGetArrayPointer(q);

    const static realtype L = XMAX-XMIN;

#pragma omp parallel for reduction(+:energy)
    for(size_t iter_x=0; iter_x<MX; iter_x++){
        Edata[iter_x]=0.;
        realtype y=x_by(iter_x);
        for(size_t iter_y=0; iter_y<MX; ++iter_y ){
            if( iter_x<=iter_y ){
                Edata[iter_x]+=(y/L-1.)*qdata[iter_y];
            } else {
                Edata[iter_x]+=(y/L)*qdata[iter_y];
            }
            y+=DX;
        }
//         Edata[iter_x] *= lambda;
        Edata[iter_x] *= DX;
        energy += std::pow(Edata[iter_x],2);
    }

    return energy*DX/2.;
}

