#!/bin/python

class extrema:
    def __init__(self,y,x=None):
        if x is None: x=range(len(y))

        self.maximum = {'x': x[0],'y': y[0], 'p': 0, 'type':'max_g'}
        self.minimum = {'x': x[0],'y': y[0], 'p': 0, 'type':'min_g'}
        self.maxima = []
        self.minima = []
        self.first = {'x': x[0],'y': y[0], 'p': 0, 'type':'bound'}
        self.last = {'x': x[-1],'y': y[-1], 'p': len(y)-1, 'type':'bound'}

        self.find_globals(x,y)
        self.find_extrema(x,y)

    def find_globals(self,x,y):
            aval=x[0]
            bval=y[0]
            for i, (a,b) in enumerate(zip(x,y)):
                if b>self.maximum['y']:
                    self.maximum['y']=b
                    self.maximum['x']=a
                    self.maximum['p']=i
                    self.maximum['type']='max_g'
                elif b<self.minimum['y']:
                    self.minimum['y']=b
                    self.minimum['x']=a
                    self.maximum['p']=i
                    self.maximum['type']='min_g'

    def find_extrema(self,x,y):
        for i in range(len(y))[1:-1]:
            if y[i] > y[i-1] and y[i]>y[i+1]:
                self.maxima.append({'x':x[i], 'y':y[i], 'p':i, 'type':'max'})
            elif y[i] < y[i-1] and y[i]<y[i+1]:
                self.minima.append({'x':x[i], 'y':y[i], 'p':i, 'type':'min'})

    def poi(self):
        output = {}
        return output
        #for a in [self.maximum, self.minimum]+self.maxima+self.minima+[self.first, self.last]:
        for a in [self.maximum, self.minimum]+[self.first, self.last]:
            output[a['p']]={'x':a['x'], 'y':a['y'], 'type': a['type']}
        ## additional filters to eliminate close points?
        return output
