#pragma once
/*
constexpr realtype deviation(const realtype& v){
    constexpr realtype pf = 2.5e-2;
    return 1.+pf*v*(v-X_LENGTH);
}*/

extern realtype deviation(const realtype&);

static void SetIC_general(const UserData& data) {
    realtype* udata = N_VGetArrayPointer(data.f);

#pragma omp parallel for
    for ( size_t iter_x=0; iter_x < MX; iter_x++) {
        realtype x = data.x(iter_x);
//         realtype x_val = 1.+1e-2*cos(2.*M_PI/length*x);
//         realtype x_val = maxwellian(x,1.,X_LENGTH/2.+XMIN);
        realtype x0 = X_LENGTH/2.+XMIN;
        realtype sigma = .1*.5*X_LENGTH;
        realtype x_val = data.n_nominal * std::exp(-std::pow((x-x0)/sigma,2)/2.)*deviation(x-x0);

        realtype vn = data.vnstart;
        for ( size_t iter_vn=0; iter_vn < MVn; iter_vn++, vn += data.dvn) {
            realtype vn_val = data.n_nominal * maxwellian<dim_v_n>(vn, data.vn_T_nominal) * x_val;

            realtype vp = data.vpstart;
            for ( size_t iter_vp=0; iter_vp< MVp; iter_vp++, vp += data.dvp){
                IJKth(udata,iter_x,iter_vn,iter_vp ) = vn_val * maxwellian(vp, data.vp_T_nominal) ;
            }
        }
    }
}
static void SetIC_ions(const UserData& data) {
    SetIC_general(data);
}

static void SetIC_electrons(const UserData& data) {
    SetIC_general(data);
}
